
function y=momspin1(u);

global Kbpoint w_spin axe_spin H jour

% Le vecteur entre est  6 composantes
% u(1:3) est le vecteur drive champ magntique B' ( B'x B'y B'z ) en axes satellite
% u(4:6) est le vecteur champ B (Bx By Bz en axes satellite
% Unit sera son vecteur unitaire

% La fonction retourne le moment magntique mx my mz plafonn  0.2 Am

% Sparation des vecteurs B et B_prime
B_prime(1:3)=u(1:3);
B(1:3)=u(4:6);

% Calcul de la matrice du produit vectoriel de u avec B
Rot=[0 -axe_spin(3) axe_spin(2)
        axe_spin(3) 0 -axe_spin(1)
            -axe_spin(2) axe_spin(1) 0];

mt_mgn1=-Kbpoint*B_prime';   % Loi en Bpoint de M Damilano

mt_mgn2=-Kbpoint*w_spin*Rot*B';   % Loi complmentaire avec la rotation de consigne
                                  % de vitesse w_spin et d'axe spin axe_spin

mt_mgn=mt_mgn1+mt_mgn2;

mt_mgm=mt_mgm-(mt_mgm*B')/norm(B);     % Optimisation du moment magntique

% Pour viter une saturation qui risque de bloquer une composante par rapport  une autre
% et donc de ne pas avoir le couple oppos  la rotation principale, je mets 
% une saturation anticipe proportionnelle, ce qui :
%	Gardera le couple oppos  la rotation transversale
%	Limitera le moment magntique des bobines  0.2 Am

maxi=[abs(mt_mgn(1)),abs(mt_mgn(2)),abs(mt_mgn(3))];

test=max(maxi);

if test>=0.2

  y=0.2*mt_mgn/test;

end

if test<0.2

  y=mt_mgn;

end  % Fin du test

end  % Fin programme
 