function y=omegaorb(u);

% Le vecteur d'entre est en colonne  8 composantes:
%   Les 4 premires du quaternion d'attitude Q
%   Les 4 dernires de la drive temporelle Q' du quaternion Q

% Le programme reconstitue le vecteur rotation du repre satellite
% par rapport au repre iorbital, ceci dans le but de vrifier que
% l'intgration est correcte

% Les 2 vecteurs rotation diffrent de w0 Y du au mouvement orbital

% omega_quat+w0Y=omega_inertiel (p q r)

quat=u(1:4);
deriv_quat=u(5:8);


% Calcul du transpos de Q

Qbarre(1)=quat(1);

Qbarre(2:4)=-quat(2:4);


% On calcule le produit 2*Drive Q*Qbarre 

omega_quat=2*prodquat(deriv_quat,Qbarre');

y(1:3)=omega_quat(2:4);

y=y';


end