function y=passage(u);

% u est un quaternion reprsentant la rotation de R1 / R0 et la fonction retourne y = Pmat la matrice de passage % associe au changement de base R0 vers R1


q0=u(1);
q1=u(2);
q2=u(3);
q3=u(4);

% Calcul de la matrice de passage

P11=2*(q0^2+q1^2)-1;P22=2*(q0^2+q2^2)-1;P33=2*(q0^2+q3^2)-1;
P21=2*(q1*q2+q0*q3);P12=2*(q1*q2-q0*q3);
P31=2*(q1*q3-q0*q2);P13=2*(q1*q3+q0*q2);
P32=2*(q2*q3+q0*q1);P23=2*(q2*q3-q0*q1);

Pmat=[P11 P12 P13;P21 P22 P23;P31 P32 P33];


y=Pmat;

end;